package eu.jonahbauer.json.query.impl;

import org.jetbrains.annotations.NotNull;

import java.util.function.Function;

record MappingGenerator<T, S>(@NotNull Generator<T> delegate, @NotNull Function<? super T, ? extends S> function) implements Generator<S> {
    @Override
    public S next() throws EndOfStreamException {
        return function.apply(delegate.next());
    }
}
