package eu.jonahbauer.json.query.parser.ast;

import eu.jonahbauer.json.JsonValue;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;
import java.util.stream.Stream;

public interface JQInvocable {
    @NotNull Stream<@Nullable JsonValue> invoke(@NotNull JQExpression.Context context, @NotNull List<@NotNull JQExpression> args);

    int arity();
    @NotNull String identifier();
    default @NotNull String reference() {
        return identifier() + "/" + arity();
    }
}
